(function(){var P$=Clazz.newPackage("jalview.datamodel.features"),I$=[[0,'java.util.ArrayList','java.util.HashSet','jalview.datamodel.features.NCList',['jalview.datamodel.features.FeatureStore','.SearchCriterion'],'jalview.datamodel.features.RangeComparator','java.util.Collections','jalview.datamodel.SequenceFeature']],$I$=function(i){return I$[i]||(I$[i]=Clazz.load(I$[0][i]))};
var C$=Clazz.newClass(P$, "FeatureStore", function(){
Clazz.newInstance(this, arguments,0,C$);
});

Clazz.newMeth(C$, '$init0$', function () {
var c;if((c = C$.superclazz) && (c = c.$init0$))c.apply(this);
this.nonPositionalFeatures=null;
this.nonNestedFeatures=null;
this.contactFeatureStarts=null;
this.contactFeatureEnds=null;
this.nestedFeatures=null;
this.positionalFeatureGroups=null;
this.nonPositionalFeatureGroups=null;
this.totalExtent=0;
this.positionalMinScore=0;
this.positionalMaxScore=0;
this.nonPositionalMinScore=0;
this.nonPositionalMaxScore=0;
}, 1);

Clazz.newMeth(C$, '$init$', function () {
}, 1);

Clazz.newMeth(C$, 'c$', function () {
C$.$init$.apply(this);
this.nonNestedFeatures=Clazz.new_(Clazz.load('java.util.ArrayList'));
this.positionalFeatureGroups=Clazz.new_(Clazz.load('java.util.HashSet'));
this.nonPositionalFeatureGroups=Clazz.new_($I$(2));
this.positionalMinScore=NaN;
this.positionalMaxScore=NaN;
this.nonPositionalMinScore=NaN;
this.nonPositionalMaxScore=NaN;
}, 1);

Clazz.newMeth(C$, 'addFeature$jalview_datamodel_SequenceFeature', function (feature) {
if (this.contains$jalview_datamodel_SequenceFeature(feature)) {
return false;
}if (!feature.isNonPositional$()) {
this.positionalFeatureGroups.add$TE(feature.getFeatureGroup$());
}var added=false;
if (feature.isContactFeature$()) {
added=this.addContactFeature$jalview_datamodel_SequenceFeature(feature);
} else if (feature.isNonPositional$()) {
added=this.addNonPositionalFeature$jalview_datamodel_SequenceFeature(feature);
} else {
added=this.addNonNestedFeature$jalview_datamodel_SequenceFeature(feature);
if (!added) {
added=this.addNestedFeature$jalview_datamodel_SequenceFeature(feature);
}}if (added) {
this.totalExtent+=C$.getFeatureLength$jalview_datamodel_SequenceFeature(feature);
var score=feature.getScore$();
if (!Float.isNaN$F(score)) {
if (feature.isNonPositional$()) {
this.nonPositionalMinScore=C$.min$F$F(this.nonPositionalMinScore, score);
this.nonPositionalMaxScore=C$.max$F$F(this.nonPositionalMaxScore, score);
} else {
this.positionalMinScore=C$.min$F$F(this.positionalMinScore, score);
this.positionalMaxScore=C$.max$F$F(this.positionalMaxScore, score);
}}}return added;
});

Clazz.newMeth(C$, 'contains$jalview_datamodel_SequenceFeature', function (feature) {
if (feature.isNonPositional$()) {
return this.nonPositionalFeatures == null  ? false : this.nonPositionalFeatures.contains$O(feature);
}if (feature.isContactFeature$()) {
return this.contactFeatureStarts == null  ? false : C$.listContains$java_util_List$jalview_datamodel_SequenceFeature(this.contactFeatureStarts, feature);
}if (C$.listContains$java_util_List$jalview_datamodel_SequenceFeature(this.nonNestedFeatures, feature)) {
return true;
}return this.nestedFeatures == null  ? false : this.nestedFeatures.contains$TT(feature);
});

Clazz.newMeth(C$, 'getFeatureLength$jalview_datamodel_SequenceFeature', function (feature) {
if (feature.isNonPositional$()) {
return 0;
}if (feature.isContactFeature$()) {
return 1;
}return 1 + feature.getEnd$() - feature.getBegin$();
}, 1);

Clazz.newMeth(C$, 'addNonPositionalFeature$jalview_datamodel_SequenceFeature', function (feature) {
if (this.nonPositionalFeatures == null ) {
this.nonPositionalFeatures=Clazz.new_($I$(1));
}this.nonPositionalFeatures.add$TE(feature);
this.nonPositionalFeatureGroups.add$TE(feature.getFeatureGroup$());
return true;
});

Clazz.newMeth(C$, 'addNestedFeature$jalview_datamodel_SequenceFeature', function (feature) {
if (this.nestedFeatures == null ) {
this.nestedFeatures=Clazz.new_(Clazz.load('jalview.datamodel.features.NCList').c$$TT,[feature]);
return true;
}return this.nestedFeatures.add$TT$Z(feature, false);
});

Clazz.newMeth(C$, 'addNonNestedFeature$jalview_datamodel_SequenceFeature', function (feature) {
{
var insertPosition=C$.binarySearch$java_util_List$jalview_datamodel_features_FeatureStore_SearchCriterion(this.nonNestedFeatures, Clazz.load(['jalview.datamodel.features.FeatureStore','.SearchCriterion']).byFeature$jalview_datamodel_ContiguousI$java_util_Comparator(feature, Clazz.load('jalview.datamodel.features.RangeComparator').BY_START_POSITION));
if (insertPosition > 0) {
if (this.encloses$jalview_datamodel_ContiguousI$jalview_datamodel_ContiguousI(this.nonNestedFeatures.get$I(insertPosition - 1), feature)) {
return false;
}}if (insertPosition < this.nonNestedFeatures.size$()) {
if (this.encloses$jalview_datamodel_ContiguousI$jalview_datamodel_ContiguousI(feature, this.nonNestedFeatures.get$I(insertPosition))) {
return false;
}}this.nonNestedFeatures.add$I$TE(insertPosition, feature);
return true;
}});

Clazz.newMeth(C$, 'encloses$jalview_datamodel_ContiguousI$jalview_datamodel_ContiguousI', function (range1, range2) {
var begin1=range1.getBegin$();
var begin2=range2.getBegin$();
var end1=range1.getEnd$();
var end2=range2.getEnd$();
if (begin1 == begin2 && end1 > end2 ) {
return true;
}if (begin1 < begin2 && end1 >= end2 ) {
return true;
}return false;
});

Clazz.newMeth(C$, 'addContactFeature$jalview_datamodel_SequenceFeature', function (feature) {
if (this.contactFeatureStarts == null ) {
this.contactFeatureStarts=Clazz.new_($I$(1));
}if (this.contactFeatureEnds == null ) {
this.contactFeatureEnds=Clazz.new_($I$(1));
}var insertPosition=C$.binarySearch$java_util_List$jalview_datamodel_features_FeatureStore_SearchCriterion(this.contactFeatureStarts, $I$(4).byFeature$jalview_datamodel_ContiguousI$java_util_Comparator(feature, $I$(5).BY_START_POSITION));
this.contactFeatureStarts.add$I$TE(insertPosition, feature);
Clazz.load('java.util.Collections').sort$java_util_List$java_util_Comparator(this.contactFeatureStarts, $I$(5).BY_START_POSITION);
insertPosition=C$.binarySearch$java_util_List$jalview_datamodel_features_FeatureStore_SearchCriterion(this.contactFeatureStarts, $I$(4).byFeature$jalview_datamodel_ContiguousI$java_util_Comparator(feature, $I$(5).BY_END_POSITION));
this.contactFeatureEnds.add$TE(feature);
$I$(6).sort$java_util_List$java_util_Comparator(this.contactFeatureEnds, $I$(5).BY_END_POSITION);
return true;
});

Clazz.newMeth(C$, 'listContains$java_util_List$jalview_datamodel_SequenceFeature', function (features, feature) {
if (features == null  || feature == null  ) {
return false;
}var pos=C$.binarySearch$java_util_List$jalview_datamodel_features_FeatureStore_SearchCriterion(features, $I$(4).byFeature$jalview_datamodel_ContiguousI$java_util_Comparator(feature, $I$(5).BY_START_POSITION));
var len=features.size$();
while (pos < len){
var sf=features.get$I(pos);
if (sf.getBegin$() > feature.getBegin$()) {
return false;
}if (sf.equals$O(feature)) {
return true;
}pos++;
}
return false;
}, 1);

Clazz.newMeth(C$, 'findOverlappingFeatures$J$J', function (start, end) {
var result=Clazz.new_($I$(1));
this.findNonNestedFeatures$J$J$java_util_List(start, end, result);
this.findContactFeatures$J$J$java_util_List(start, end, result);
if (this.nestedFeatures != null ) {
result.addAll$java_util_Collection(this.nestedFeatures.findOverlaps$J$J(start, end));
}return result;
});

Clazz.newMeth(C$, 'findContactFeatures$J$J$java_util_List', function (from, to, result) {
if (this.contactFeatureStarts != null ) {
this.findContactStartFeatures$J$J$java_util_List(from, to, result);
}if (this.contactFeatureEnds != null ) {
this.findContactEndFeatures$J$J$java_util_List(from, to, result);
}});

Clazz.newMeth(C$, 'findContactEndFeatures$J$J$java_util_List', function (from, to, result) {
var startPosition=C$.binarySearch$java_util_List$jalview_datamodel_features_FeatureStore_SearchCriterion(this.contactFeatureEnds, $I$(4).byEnd$J(from));
for (; startPosition < this.contactFeatureEnds.size$(); startPosition++) {
var sf=this.contactFeatureEnds.get$I(startPosition);
if (!sf.isContactFeature$()) {
System.err.println$S("Error! non-contact feature type " + sf.getType$() + " in contact features list" );
continue;
}var begin=sf.getBegin$();
if (begin >= from && begin <= to ) {
continue;
}var end=sf.getEnd$();
if (end >= from && end <= to ) {
result.add$TE(sf);
}if (end > to) {
break;
}}
});

Clazz.newMeth(C$, 'findNonNestedFeatures$J$J$java_util_List', function (from, to, result) {
var startIndex=C$.binarySearch$java_util_List$jalview_datamodel_features_FeatureStore_SearchCriterion(this.nonNestedFeatures, $I$(4).byEnd$J(from));
var startIndex1=startIndex;
var i=startIndex1;
while (i < this.nonNestedFeatures.size$()){
var sf=this.nonNestedFeatures.get$I(i);
if (sf.getBegin$() > to) {
break;
}if (sf.getBegin$() <= to && sf.getEnd$() >= from ) {
result.add$TE(sf);
}i++;
}
});

Clazz.newMeth(C$, 'findContactStartFeatures$J$J$java_util_List', function (from, to, result) {
var startPosition=C$.binarySearch$java_util_List$jalview_datamodel_features_FeatureStore_SearchCriterion(this.contactFeatureStarts, $I$(4).byStart$J(from));
for (; startPosition < this.contactFeatureStarts.size$(); startPosition++) {
var sf=this.contactFeatureStarts.get$I(startPosition);
if (!sf.isContactFeature$()) {
System.err.println$S("Error! non-contact feature type " + sf.getType$() + " in contact features list" );
continue;
}var begin=sf.getBegin$();
if (begin >= from && begin <= to ) {
result.add$TE(sf);
}}
});

Clazz.newMeth(C$, 'getPositionalFeatures$', function () {
var result=Clazz.new_($I$(1));
result.addAll$java_util_Collection(this.nonNestedFeatures);
if (this.contactFeatureStarts != null ) {
result.addAll$java_util_Collection(this.contactFeatureStarts);
}if (this.nestedFeatures != null ) {
result.addAll$java_util_Collection(this.nestedFeatures.getEntries$());
}return result;
});

Clazz.newMeth(C$, 'getContactFeatures$', function () {
if (this.contactFeatureStarts == null ) {
return $I$(6).emptyList$();
}return Clazz.new_($I$(1).c$$java_util_Collection,[this.contactFeatureStarts]);
});

Clazz.newMeth(C$, 'getNonPositionalFeatures$', function () {
if (this.nonPositionalFeatures == null ) {
return $I$(6).emptyList$();
}return Clazz.new_($I$(1).c$$java_util_Collection,[this.nonPositionalFeatures]);
});

Clazz.newMeth(C$, 'delete$jalview_datamodel_SequenceFeature', function (sf) {
var removed=this.nonNestedFeatures.remove$O(sf);
if (!removed && this.contactFeatureStarts != null  ) {
removed=this.contactFeatureStarts.remove$O(sf);
if (removed) {
this.contactFeatureEnds.remove$O(sf);
}}var removedNonPositional=false;
if (!removed && this.nonPositionalFeatures != null  ) {
removedNonPositional=this.nonPositionalFeatures.remove$O(sf);
removed=removedNonPositional;
}if (!removed && this.nestedFeatures != null  ) {
removed=this.nestedFeatures.delete$TT(sf);
}if (removed) {
this.rescanAfterDelete$();
}return removed;
});

Clazz.newMeth(C$, 'rescanAfterDelete$', function () {
this.positionalFeatureGroups.clear$();
this.nonPositionalFeatureGroups.clear$();
this.totalExtent=0;
this.positionalMinScore=NaN;
this.positionalMaxScore=NaN;
this.nonPositionalMinScore=NaN;
this.nonPositionalMaxScore=NaN;
for (var sf, $sf = this.getNonPositionalFeatures$().iterator$(); $sf.hasNext$()&&((sf=($sf.next$())),1);) {
this.nonPositionalFeatureGroups.add$TE(sf.getFeatureGroup$());
var score=sf.getScore$();
this.nonPositionalMinScore=C$.min$F$F(this.nonPositionalMinScore, score);
this.nonPositionalMaxScore=C$.max$F$F(this.nonPositionalMaxScore, score);
}
for (var sf, $sf = this.getPositionalFeatures$().iterator$(); $sf.hasNext$()&&((sf=($sf.next$())),1);) {
this.positionalFeatureGroups.add$TE(sf.getFeatureGroup$());
var score=sf.getScore$();
this.positionalMinScore=C$.min$F$F(this.positionalMinScore, score);
this.positionalMaxScore=C$.max$F$F(this.positionalMaxScore, score);
this.totalExtent+=C$.getFeatureLength$jalview_datamodel_SequenceFeature(sf);
}
});

Clazz.newMeth(C$, 'min$F$F', function (f1, f2) {
if (Float.isNaN$F(f1)) {
return Float.isNaN$F(f2) ? f1 : f2;
} else {
return Float.isNaN$F(f2) ? f1 : Math.min(f1, f2);
}}, 1);

Clazz.newMeth(C$, 'max$F$F', function (f1, f2) {
if (Float.isNaN$F(f1)) {
return Float.isNaN$F(f2) ? f1 : f2;
} else {
return Float.isNaN$F(f2) ? f1 : Math.max(f1, f2);
}}, 1);

Clazz.newMeth(C$, 'isEmpty$', function () {
var hasFeatures=!this.nonNestedFeatures.isEmpty$() || (this.contactFeatureStarts != null  && !this.contactFeatureStarts.isEmpty$() ) || (this.nonPositionalFeatures != null  && !this.nonPositionalFeatures.isEmpty$() ) || (this.nestedFeatures != null  && this.nestedFeatures.size$() > 0 )  ;
return !hasFeatures;
});

Clazz.newMeth(C$, 'getFeatureGroups$Z', function (positionalFeatures) {
if (positionalFeatures) {
return $I$(6).unmodifiableSet$java_util_Set(this.positionalFeatureGroups);
} else {
return this.nonPositionalFeatureGroups == null  ? $I$(6).emptySet$() : $I$(6).unmodifiableSet$java_util_Set(this.nonPositionalFeatureGroups);
}});

Clazz.newMeth(C$, 'binarySearch$java_util_List$jalview_datamodel_features_FeatureStore_SearchCriterion', function (features, sc) {
var start=0;
var end=features.size$() - 1;
var matched=features.size$();
while (start <= end){
var mid=((start + end)/2|0);
var entry=features.get$I(mid);
var compare=sc.compare$jalview_datamodel_SequenceFeature(entry);
if (compare) {
matched=mid;
end=mid - 1;
} else {
start=mid + 1;
}}
return matched;
}, 1);

Clazz.newMeth(C$, 'getFeatureCount$Z', function (positional) {
if (!positional) {
return this.nonPositionalFeatures == null  ? 0 : this.nonPositionalFeatures.size$();
}var size=this.nonNestedFeatures.size$();
if (this.contactFeatureStarts != null ) {
size+=this.contactFeatureStarts.size$();
}if (this.nestedFeatures != null ) {
size+=this.nestedFeatures.size$();
}return size;
});

Clazz.newMeth(C$, 'getTotalFeatureLength$', function () {
return this.totalExtent;
});

Clazz.newMeth(C$, 'getMinimumScore$Z', function (positional) {
return positional ? this.positionalMinScore : this.nonPositionalMinScore;
});

Clazz.newMeth(C$, 'getMaximumScore$Z', function (positional) {
return positional ? this.positionalMaxScore : this.nonPositionalMaxScore;
});

Clazz.newMeth(C$, 'getFeaturesForGroup$Z$S', function (positional, group) {
var result=Clazz.new_($I$(1));
if (positional && !this.positionalFeatureGroups.contains$O(group)  || !positional && !this.nonPositionalFeatureGroups.contains$O(group)  ) {
return result;
}var sfs=positional ? this.getPositionalFeatures$() : this.getNonPositionalFeatures$();
for (var sf, $sf = sfs.iterator$(); $sf.hasNext$()&&((sf=($sf.next$())),1);) {
var featureGroup=sf.getFeatureGroup$();
if (group == null  && featureGroup == null   || group != null  && group.equals$O(featureGroup)  ) {
result.add$TE(sf);
}}
return result;
});

Clazz.newMeth(C$, 'shiftFeatures$I', function (shift) {
var modified=false;
for (var sf, $sf = this.getPositionalFeatures$().iterator$(); $sf.hasNext$()&&((sf=($sf.next$())),1);) {
modified=true;
var newBegin=sf.getBegin$() + shift;
var newEnd=sf.getEnd$() + shift;
if (newEnd > 0) {
newBegin=Math.max(1, newBegin);
var sf2=Clazz.new_(Clazz.load('jalview.datamodel.SequenceFeature').c$$jalview_datamodel_SequenceFeature$I$I$S$F,[sf, newBegin, newEnd, sf.getFeatureGroup$(), sf.getScore$()]);
this.addFeature$jalview_datamodel_SequenceFeature(sf2);
}this.delete$jalview_datamodel_SequenceFeature(sf);
}
return modified;
});
;
(function(){var C$=Clazz.newClass(P$.FeatureStore, "SearchCriterion", function(){
Clazz.newInstance(this, arguments[0],false,C$);
});

Clazz.newMeth(C$, '$init$', function () {
}, 1);

Clazz.newMeth(C$, 'byStart$J', function (target) {
return ((P$.FeatureStore$SearchCriterion$1||
(function(){var C$=Clazz.newClass(P$, "FeatureStore$SearchCriterion$1", function(){Clazz.newInstance(this, arguments[0],1,C$);}, Clazz.load(['jalview.datamodel.features.FeatureStore','.SearchCriterion']), null, 1);

C$.$clinit$ = function() {Clazz.load(C$, 1);
}

Clazz.newMeth(C$, '$init$', function () {
}, 1);

Clazz.newMeth(C$, 'compare$jalview_datamodel_SequenceFeature', function (entry) {
return entry.getBegin$() >= this.$finals$.target;
});
})()
), Clazz.new_(C$, [this, {target: target}],P$.FeatureStore$SearchCriterion$1));
}, 1);

Clazz.newMeth(C$, 'byEnd$J', function (target) {
return ((P$.FeatureStore$SearchCriterion$2||
(function(){var C$=Clazz.newClass(P$, "FeatureStore$SearchCriterion$2", function(){Clazz.newInstance(this, arguments[0],1,C$);}, Clazz.load(['jalview.datamodel.features.FeatureStore','.SearchCriterion']), null, 1);

C$.$clinit$ = function() {Clazz.load(C$, 1);
}

Clazz.newMeth(C$, '$init$', function () {
}, 1);

Clazz.newMeth(C$, 'compare$jalview_datamodel_SequenceFeature', function (entry) {
return entry.getEnd$() >= this.$finals$.target;
});
})()
), Clazz.new_(C$, [this, {target: target}],P$.FeatureStore$SearchCriterion$2));
}, 1);

Clazz.newMeth(C$, 'byFeature$jalview_datamodel_ContiguousI$java_util_Comparator', function (to, rc) {
return ((P$.FeatureStore$SearchCriterion$3||
(function(){var C$=Clazz.newClass(P$, "FeatureStore$SearchCriterion$3", function(){Clazz.newInstance(this, arguments[0],1,C$);}, Clazz.load(['jalview.datamodel.features.FeatureStore','.SearchCriterion']), null, 1);

C$.$clinit$ = function() {Clazz.load(C$, 1);
}

Clazz.newMeth(C$, '$init$', function () {
}, 1);

Clazz.newMeth(C$, 'compare$jalview_datamodel_SequenceFeature', function (entry) {
return this.$finals$.rc.compare$(entry, this.$finals$.to) >= 0;
});
})()
), Clazz.new_(C$, [this, {rc: rc, to: to}],P$.FeatureStore$SearchCriterion$3));
}, 1);

Clazz.newMeth(C$);
})()
})();
;Clazz.setTVer('3.2.2.04');//Created 2018-08-26 06:33:30 Java2ScriptVisitor version 3.2.2.04 net.sf.j2s.core.jar version 3.2.2.04
